Given a time represented in the format "HH:MM", form the next closest time by reusing the current digits. There is no limit on how many times a digit can be reused.
You may assume the given input string is always valid. For example, "01:34", "12:09" are all valid. "1:34", "12:9" are all invalid.
Example 1:
Input: "19:34" Output: "19:39" Explanation: The next closest time choosing from digits 1, 9, 3, 4, is 19:39, which occurs 5 minutes later. It is not 19:33, because this occurs 23 hours and 59 minutes later.
Example 2:
Input: "23:59" Output: "22:22" Explanation: The next closest time choosing from digits 2, 3, 5, 9, is 22:22. It may be assumed that the returned time is next day's time since it is smaller than the input time numerically.
最优解法,时间复杂度为O(4*10),空间复杂度为O(10),思路:用一个伪哈希表来存给的时间的数字,然后从第四位开始,去哈希表里找有没有比给定的第四位大而且合法的数字,如果有则返回带有这个合法数字的新的string;如果没有,就把第四位设为哈希表里的最小值。依次类推,从第四位走到第一位,如果第一位还不存在一个比它大的合法值,则四位都设为最小值,然后返回,此时对应的情况就是example2里的情况,返回的是第二天的最小时间。此解法简单易懂,而且效率很高,beats 96%的leetcoder
public class NextClosestTime {
public String nextClosetTime(String time) {
char[] t = time.toCharArray(), result = new char[4];
int[] list = new int[10];
char min = '9';
for (char c : t) {
if (c == ':') {
continue;
}
list[c - '0']++;
if (c < min) {
min = c;
}
}
for (int i = t[4] - '0' + 1; i <= 9; i++) {
if (list[i] != 0) {
t[4] = (char)(i + '0');
return new String(t);
}
}
t[4] = min;
for (int i = t[3] - '0' + 1; i <= 5; i++) {
if (list[i] != 0) {
t[3] = (char)(i + '0');
return new String(t);
}
}
t[3] = min;
int stop = t[0] < '2' ? 9 : 3;
for (int i = t[1] - '0' + 1; i <= stop; i++) {
if (list[i] != 0) {
t[1] = (char)(i + '0');
return new String(t);
}
}
t[1] = min;
for (int i = t[0] - '0' + 1; i <= 2; i++) {
if (list[i] != 0) {
t[0] = (char)(i + '0');
return new String(t);
}
}
t[0] = min;
return new String(t);
}
public static void main(String[] args) {
NextClosestTime ts = new NextClosestTime();
String time = "23:56";
String res = ts.nextClosetTime(time);
System.out.println(res);
}
}